using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Globalization;

namespace StarDelta
{
	/// <summary>
	/// Summary description for FormMain.
	/// </summary>
	
	enum Mode { Star2Delta, Delta2Star };

	public class FormMain : System.Windows.Forms.Form
	{
		StarDelta starDelta = new StarDelta();
		NumberFormatInfo formatInfo = NumberFormatInfo.CurrentInfo;
		Mode mode;

		#region Designer
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.Windows.Forms.GroupBox gBoxStarCircuit;
		private System.Windows.Forms.Label lblR1;
		private System.Windows.Forms.TextBox editR1;
		private System.Windows.Forms.TextBox editR2;
		private System.Windows.Forms.Label lblR2;
		private System.Windows.Forms.TextBox editR3;
		private System.Windows.Forms.Label lblR3;
		private System.Windows.Forms.GroupBox gBoxDeltaCircuit;
		private System.Windows.Forms.TextBox editRb;
		private System.Windows.Forms.Label lblRb;
		private System.Windows.Forms.TextBox editRa;
		private System.Windows.Forms.Label lblRa;
		private System.Windows.Forms.TextBox editRc;
		private System.Windows.Forms.Label lblRc;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.PictureBox pictureBox2;
		private System.Windows.Forms.Label lblInfo;

		private System.ComponentModel.Container components = null;
		#endregion

		public FormMain()
		{
			InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormMain));
			this.gBoxStarCircuit = new System.Windows.Forms.GroupBox();
			this.lblR1 = new System.Windows.Forms.Label();
			this.editR1 = new System.Windows.Forms.TextBox();
			this.editR2 = new System.Windows.Forms.TextBox();
			this.lblR2 = new System.Windows.Forms.Label();
			this.editR3 = new System.Windows.Forms.TextBox();
			this.lblR3 = new System.Windows.Forms.Label();
			this.gBoxDeltaCircuit = new System.Windows.Forms.GroupBox();
			this.editRb = new System.Windows.Forms.TextBox();
			this.lblRb = new System.Windows.Forms.Label();
			this.editRa = new System.Windows.Forms.TextBox();
			this.lblRa = new System.Windows.Forms.Label();
			this.editRc = new System.Windows.Forms.TextBox();
			this.lblRc = new System.Windows.Forms.Label();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.lblInfo = new System.Windows.Forms.Label();
			this.gBoxStarCircuit.SuspendLayout();
			this.gBoxDeltaCircuit.SuspendLayout();
			this.SuspendLayout();
			// 
			// gBoxStarCircuit
			// 
			this.gBoxStarCircuit.Controls.Add(this.lblR1);
			this.gBoxStarCircuit.Controls.Add(this.editR1);
			this.gBoxStarCircuit.Controls.Add(this.editR2);
			this.gBoxStarCircuit.Controls.Add(this.lblR2);
			this.gBoxStarCircuit.Controls.Add(this.editR3);
			this.gBoxStarCircuit.Controls.Add(this.lblR3);
			this.gBoxStarCircuit.Location = new System.Drawing.Point(16, 240);
			this.gBoxStarCircuit.Name = "gBoxStarCircuit";
			this.gBoxStarCircuit.Size = new System.Drawing.Size(224, 136);
			this.gBoxStarCircuit.TabIndex = 3;
			this.gBoxStarCircuit.TabStop = false;
			this.gBoxStarCircuit.Text = "Star circuit";
			this.gBoxStarCircuit.Enter += new System.EventHandler(this.gBoxStarCircuit_Enter);
			// 
			// lblR1
			// 
			this.lblR1.Location = new System.Drawing.Point(16, 24);
			this.lblR1.Name = "lblR1";
			this.lblR1.Size = new System.Drawing.Size(32, 24);
			this.lblR1.TabIndex = 8;
			this.lblR1.Text = "R1:";
			this.lblR1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// editR1
			// 
			this.editR1.Location = new System.Drawing.Point(56, 24);
			this.editR1.Name = "editR1";
			this.editR1.Size = new System.Drawing.Size(152, 20);
			this.editR1.TabIndex = 1;
			this.editR1.Text = "";
			this.editR1.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.editR1.TextChanged += new System.EventHandler(this.editR1_TextChanged);
			// 
			// editR2
			// 
			this.editR2.Location = new System.Drawing.Point(56, 64);
			this.editR2.Name = "editR2";
			this.editR2.Size = new System.Drawing.Size(152, 20);
			this.editR2.TabIndex = 2;
			this.editR2.Text = "";
			this.editR2.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.editR2.TextChanged += new System.EventHandler(this.editR2_TextChanged);
			// 
			// lblR2
			// 
			this.lblR2.Location = new System.Drawing.Point(16, 64);
			this.lblR2.Name = "lblR2";
			this.lblR2.Size = new System.Drawing.Size(32, 24);
			this.lblR2.TabIndex = 9;
			this.lblR2.Text = "R2:";
			this.lblR2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// editR3
			// 
			this.editR3.Location = new System.Drawing.Point(56, 101);
			this.editR3.Name = "editR3";
			this.editR3.Size = new System.Drawing.Size(152, 20);
			this.editR3.TabIndex = 3;
			this.editR3.Text = "";
			this.editR3.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.editR3.TextChanged += new System.EventHandler(this.editR3_TextChanged);
			// 
			// lblR3
			// 
			this.lblR3.Location = new System.Drawing.Point(16, 100);
			this.lblR3.Name = "lblR3";
			this.lblR3.Size = new System.Drawing.Size(32, 24);
			this.lblR3.TabIndex = 7;
			this.lblR3.Text = "R3:";
			this.lblR3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// gBoxDeltaCircuit
			// 
			this.gBoxDeltaCircuit.Controls.Add(this.editRb);
			this.gBoxDeltaCircuit.Controls.Add(this.lblRb);
			this.gBoxDeltaCircuit.Controls.Add(this.editRa);
			this.gBoxDeltaCircuit.Controls.Add(this.lblRa);
			this.gBoxDeltaCircuit.Controls.Add(this.editRc);
			this.gBoxDeltaCircuit.Controls.Add(this.lblRc);
			this.gBoxDeltaCircuit.Location = new System.Drawing.Point(296, 239);
			this.gBoxDeltaCircuit.Name = "gBoxDeltaCircuit";
			this.gBoxDeltaCircuit.Size = new System.Drawing.Size(224, 137);
			this.gBoxDeltaCircuit.TabIndex = 4;
			this.gBoxDeltaCircuit.TabStop = false;
			this.gBoxDeltaCircuit.Text = "Delta circuit";
			this.gBoxDeltaCircuit.Enter += new System.EventHandler(this.gBoxDeltaCircuit_Enter);
			// 
			// editRb
			// 
			this.editRb.Location = new System.Drawing.Point(56, 60);
			this.editRb.Name = "editRb";
			this.editRb.Size = new System.Drawing.Size(152, 20);
			this.editRb.TabIndex = 5;
			this.editRb.Text = "";
			this.editRb.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.editRb.TextChanged += new System.EventHandler(this.editRb_TextChanged);
			// 
			// lblRb
			// 
			this.lblRb.Location = new System.Drawing.Point(16, 60);
			this.lblRb.Name = "lblRb";
			this.lblRb.Size = new System.Drawing.Size(32, 24);
			this.lblRb.TabIndex = 7;
			this.lblRb.Text = "Rb:";
			this.lblRb.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// editRa
			// 
			this.editRa.Location = new System.Drawing.Point(56, 20);
			this.editRa.Name = "editRa";
			this.editRa.Size = new System.Drawing.Size(152, 20);
			this.editRa.TabIndex = 4;
			this.editRa.Text = "";
			this.editRa.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.editRa.TextChanged += new System.EventHandler(this.editRa_TextChanged);
			// 
			// lblRa
			// 
			this.lblRa.Location = new System.Drawing.Point(16, 20);
			this.lblRa.Name = "lblRa";
			this.lblRa.Size = new System.Drawing.Size(32, 24);
			this.lblRa.TabIndex = 8;
			this.lblRa.Text = "Ra:";
			this.lblRa.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// editRc
			// 
			this.editRc.Location = new System.Drawing.Point(56, 100);
			this.editRc.Name = "editRc";
			this.editRc.Size = new System.Drawing.Size(152, 20);
			this.editRc.TabIndex = 6;
			this.editRc.Text = "";
			this.editRc.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.editRc.TextChanged += new System.EventHandler(this.editRc_TextChanged);
			// 
			// lblRc
			// 
			this.lblRc.Location = new System.Drawing.Point(16, 100);
			this.lblRc.Name = "lblRc";
			this.lblRc.Size = new System.Drawing.Size(32, 24);
			this.lblRc.TabIndex = 6;
			this.lblRc.Text = "Rc:";
			this.lblRc.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(32, 16);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(180, 180);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox1.TabIndex = 5;
			this.pictureBox1.TabStop = false;
			// 
			// pictureBox2
			// 
			this.pictureBox2.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox2.Image")));
			this.pictureBox2.Location = new System.Drawing.Point(312, 16);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(180, 180);
			this.pictureBox2.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.pictureBox2.TabIndex = 6;
			this.pictureBox2.TabStop = false;
			// 
			// lblInfo
			// 
			this.lblInfo.BackColor = System.Drawing.SystemColors.ControlLight;
			this.lblInfo.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblInfo.Location = new System.Drawing.Point(16, 208);
			this.lblInfo.Name = "lblInfo";
			this.lblInfo.Size = new System.Drawing.Size(504, 24);
			this.lblInfo.TabIndex = 7;
			this.lblInfo.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// FormMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(538, 398);
			this.Controls.Add(this.lblInfo);
			this.Controls.Add(this.pictureBox2);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.gBoxDeltaCircuit);
			this.Controls.Add(this.gBoxStarCircuit);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.Name = "FormMain";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Star - Delta Transformation";
			this.Load += new System.EventHandler(this.FormMain_Load);
			this.gBoxStarCircuit.ResumeLayout(false);
			this.gBoxDeltaCircuit.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormMain());
		}

		// to prevent a circular call of OnStarChanged and OnDeltaChanged
		// we use the mode information

		void OnStarChanged()
		{
			if (mode == Mode.Star2Delta)
			{
				starDelta.StarToDelta();
				editRa.Text = starDelta.Ra.ToString("0.00");
				editRb.Text = starDelta.Rb.ToString("0.00");
				editRc.Text = starDelta.Rc.ToString("0.00");
				UpdateInfo();
			}
		}

		void OnDeltaChanged()
		{
			if (mode == Mode.Delta2Star)
			{
				starDelta.DeltaToStar();
				editR1.Text = starDelta.R1.ToString("0.00");
				editR2.Text = starDelta.R2.ToString("0.00");
				editR3.Text = starDelta.R3.ToString("0.00");
				UpdateInfo();
			}
		}

		void UpdateInfo()
		{
			double R12 = starDelta.RDelta(1, 2);
			double R23 = starDelta.RDelta(2, 3);
			double R31 = starDelta.RDelta(3, 1);
			string info = String.Format("R12 = {0:0.00}   |    R23 = {1:0.00}    |     R31 = {2:0.00}", R12, R23, R31);
			lblInfo.Text = info;
		}

		private void editR1_TextChanged(object sender, System.EventArgs e)
		{
			// calculate new values only with valid double values
			double d;
			if (Double.TryParse(editR1.Text, NumberStyles.Float , formatInfo , out d))
			{
				starDelta.R1 = d;
				OnStarChanged();
			}
			else
			{
				MessageBox.Show(this, "Please enter a number!", "R1: Error");
			}
		}

		private void editR2_TextChanged(object sender, System.EventArgs e)
		{
			double d;
			if (Double.TryParse(editR2.Text, NumberStyles.Float , formatInfo , out d))
			{
				starDelta.R2 = d;
				OnStarChanged();
			}
			else
			{
				MessageBox.Show(this, "Please enter a number!", "R2: Error");
			}
		}

		private void editR3_TextChanged(object sender, System.EventArgs e)
		{
			double d;
			if (Double.TryParse(editR3.Text, NumberStyles.Float , formatInfo , out d))
			{
				starDelta.R3 = d;
				OnStarChanged();
			}
			else
			{
				MessageBox.Show(this, "Please enter a number!", "R3: Error");
			}
		}

		private void editRa_TextChanged(object sender, System.EventArgs e)
		{
			double d;
			if (Double.TryParse(editRa.Text, NumberStyles.Float , formatInfo , out d))
			{
				starDelta.Ra = d;
				OnDeltaChanged();
			}
			else
			{
				MessageBox.Show(this, "Please enter a number!", "Ra: Error");
			}
		}

		private void editRb_TextChanged(object sender, System.EventArgs e)
		{
			double d;
			if (Double.TryParse(editRb.Text, NumberStyles.Float , formatInfo , out d))
			{
				starDelta.Rb = d;
				OnDeltaChanged();
			}
			else
			{
				MessageBox.Show(this, "Please enter a number!", "Rb: Error");
			}
		}

		private void editRc_TextChanged(object sender, System.EventArgs e)
		{
			double d;
			if (Double.TryParse(editRc.Text, NumberStyles.Float , formatInfo , out d))
			{
				starDelta.Rc = d;
				OnDeltaChanged();
			}
			else
			{
				MessageBox.Show(this, "Please enter a number!", "Rc: Error");
			}
		}

		private void FormMain_Load(object sender, System.EventArgs e)
		{
			mode = Mode.Star2Delta;
			OnStarChanged();
			// get the star values
			mode = Mode.Delta2Star;
			OnDeltaChanged();
			editR1.Focus();
		}

		private void gBoxStarCircuit_Enter(object sender, System.EventArgs e)
		{
			// one of the edit controls in the star circuit group box has the focus
			mode = Mode.Star2Delta;
		}

		private void gBoxDeltaCircuit_Enter(object sender, System.EventArgs e)
		{
			mode = Mode.Delta2Star;		
		}

	}
}
